/* MailTweak internal component - Copyright (C) 2007, 2008 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
const xulns = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
const htmlns = "http://www.w3.org/1999/xhtml"
const ignore = {
action: true,bindings: true,broadcaster: true,broadcasterset: true,command: true,commandset: true,conditions: true,data: true,key: true,keyset: true,preference: true,preferences: true,rule: true,script: true,stringbundle: true,stringbundleset: true,template: true}
targetWindow = null, elem = null, original = null
previous = null, next = null, parent = null, child = null
Fake = function (tree, row, col, type) {
this.tree = tree
this.row = row < 0? 0 : row
this.col = col
this.type = type
if (!type) this.type = "row", this.col = null
var treebox = tree.boxObject
var body = treebox.treeBody
if (!body) body = tree.getElementsByTagName("treechildren")[0]
var box = body.boxObject
var rh = tree.treeBoxObject.rowHeight
var x = {}, y = {}, w = {}, h = {}
if (row < treebox.getFirstVisibleRow() || row > treebox.getLastVisibleRow()) {
this.boxObject = {x: 0, y: 0, width: 0, height: 0}}
else if (type == "row") {
tree.treeBoxObject.getCoordsForCellItem(row, tree.columns.getFirstColumn(), "text", x, y, w, h)
this.boxObject = {
x: box.x,y: y.value + box.y,width: box.width,height: rh}}
else {
tree.treeBoxObject.getCoordsForCellItem(row, tree.columns.getColumnAt(col), type, x, y, w, h)
if (type == "twisty") tree.treeBoxObject.getCoordsForCellItem(row, tree.columns.getColumnAt(col), "text", {}, y, {}, h)
this.boxObject = {
x: x.value + box.x,y: y.value + box.y,width: w.value,height: rh}}}
Fake.prototype = {
isFake: true,prefix: "",namespaceURI: xulns,get exists () {
return true},get firstChild () {
switch (this.type) {
case "row":
return new Fake(this.tree, this.row, 0, "cell")
case "cell":
var f = new Fake(this.tree, this.row, this.col, "twisty")
return f.exists? f : f.nextSibling
case "twisty":
case "image":
case "text":
return null}},get nextSibling () {
switch (this.type) {
case "row":
var r = this.row + 1
if (r == this.tree.view.rowCount) return null
else return new Fake(this.tree, r, null, "row")
case "cell":
var c = this.col + 1
if (c == this.tree.columns.count) return null
return new Fake(this.tree, this.row, c, "cell")
case "twisty":
var f = new Fake(this.tree, this.row, this.col, "image")
return f.exists? f : f.nextSibling
case "image":
var f = new Fake(this.tree, this.row, this.col, "text")
return f.exists? f : f.nextSibling
case "text":
return null}},get parentNode () {
switch (this.type) {
case "row":
return this.tree.getElementsByTagName("treechildren")[0]
case "cell":
return new Fake(this.tree, this.row, null, "row")
case "twisty":
case "image":
case "text":
return new Fake(this.tree, this.row, this.col, "cell")}},get previousSibling () {
switch (this.type) {
case "row":
if (this.row == 0) return null
else return new Fake(this.tree, this.row - 1, null, "row")
case "cell":
if (this.col == 0) return null
return new Fake(this.tree, this.row, this.col - 1, "cell")
case "twisty":
return null
case "image":
var f = new Fake(this.tree, this.row, this.col, "twisty")
return f.exists? f : f.previousSibling
case "text":
var f = new Fake(this.tree, this.row, this.col, "image")
return f.exists? f : f.previousSibling}},get localName () {
return "treechildren::-moz-tree-"
+ (this.type == "text"? "cell-text" : this.type)},get ownerDocument () {
return this.tree.ownerDocument},get properties () {
var a = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray)
switch (this.type) {
case "row":
this.tree.view.getRowProperties(this.row, a)
break
case "cell":
case "twisty":
case "image":
case "text":
this.tree.view.getCellProperties(this.row, this.tree.columns.getColumnAt(this.col), a)
break}
var n = a.Count(), r = []
for (var i = 0; i < n; ++i)
r.push(a.GetElementAt(i).QueryInterface(Components.interfaces.nsIAtom).toString())
return r},toString: function () {return "[object Fake " + this.type + "]"}}
CBH = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper)
DU = Components.classes["@mozilla.org/inspector/dom-utils;1"].getService(Components.interfaces.inIDOMUtils)
OBS = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
PRF = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.msgnumber.")
TW = Components.classes["@mozilla.org/inspector/deep-tree-walker;1"].createInstance(Components.interfaces.inIDeepTreeWalker)
TW.showAnonymousContent = true
TW.showSubDocuments = true
WW = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher)
copyPopup = function () {
var f = document.commandDispatcher.focusedElement
return Boolean(f &&
((f.localName == "input" && f.value) || (f.localName == "listbox" && f.selectedCount)))}
copyText = function () {
var f = document.commandDispatcher.focusedElement
if (!f) return
if (f.parentNode.parentNode.id == "namespace")
var txt = '@namespace ' + f.value + ' url("' + elem.namespaceURI + '");'
else if (f.localName == "input")
var txt = f.value
else if (f.localName == "listbox") {
var txt = ""
for each (var i in f.selectedItems) txt += (txt == ""? "":" ") + i.getAttribute("label")}
if (txt && f.id == "property") txt = "(" + txt + ")"
CBH.copyString(txt)}
display = function () {
var chrome = (elem.ownerDocument? elem.ownerDocument : elem).location.href.match(/^chrome:\/\/[^\/]+\/content[\/]/)
document.getElementById("css-file").value = chrome? "userChrome.css" : "userContent.css",document.getElementById("open-button").disabled = false
parent = DU.getParentForNode(elem, true)
if (elem.localName == "treechildren") {
while (parent.localName != "tree") {
parent = parent.parentNode
if (parent.localName == "treechildren") elem = parent}
elem = parent.getElementsByTagName("treechildren")[0]}
if (elem.isFake) {
parent = elem.parentNode
next = elem.nextSibling
previous = elem.previousSibling
child = elem.firstChild
showPseud(true)}
else {
TW.init(parent, Components.interfaces.nsIDOMNodeFilter.SHOW_ALL)
previous = null, next = null, child = null, sib = false
var e = TW.currentNode, grand = DU.getParentForNode(parent, true)
var ewas = null, epar = DU.getParentForNode(e, true)
while (e) {
if (e.localName && !ignore[e.localName]) {
sib = (epar == parent)
if (sib && e == elem) previous = ewas
if (sib && ewas == elem) next = e
if (!child && epar == elem) child = e
if (sib) ewas = e}
e = TW.nextNode()
if (e) epar = DU.getParentForNode(e, true)
if (e && epar == grand) break}
if (elem.localName == "treechildren")
child = new Fake(parent, 0, null, "row")
else if (elem.localName == "browser" || elem.localName == "iframe")
child = elem.contentDocument.documentElement
else if (elem == elem.ownerDocument.documentElement) {
parent = null
var p = elem.ownerDocument.defaultView
var d = targetWindow.document
var b = d.getElementsByTagName("browser")
for (var i = 0; i < b.length; ++i) {
if (b[i].contentWindow == p) {
parent = b[i]
break}}
if (!parent) {
b = d.getElementsByTagName("iframe")
for (var i = 0; i < b.length; ++i) {
if (b[i].contentWindow == p) {
parent = b[i]
break}}}}
showPseud(false)}
if (parent instanceof Components.interfaces.nsIDOMDocument) parent = null
with (document.getElementById("goto-parent"))
disabled = !Boolean(parent),parent? setAttribute("tooltiptext", parent.localName) : removeAttribute("tooltiptext")
with (document.getElementById("goto-child"))
disabled = !Boolean(child),child? setAttribute("tooltiptext", child.localName) : removeAttribute("tooltiptext")
with (document.getElementById("goto-previous"))
disabled = !Boolean(previous),previous? setAttribute("tooltiptext", previous.localName) : removeAttribute("tooltiptext")
with (document.getElementById("goto-next"))
disabled = !Boolean(next),next? setAttribute("tooltiptext", next.localName) : removeAttribute("tooltiptext")
setValue("type", elem.localName)
setValue("id", elem.id? "#" + elem.id : "")
clearRows("class")
if (elem.className) {
var cc = elem.className.split(" ")
for each (var c in cc) if (c) addRow("class", "." + c)}
clearRows("attribute")
var aa = elem.attributes
for each (var a in aa)
if (a.nodeName && a.nodeName != "id" && a.nodeName != "class")
addRow("attribute", '[' + a.nodeName + '="' + a.nodeValue + '"]')
clearRows("property")
var pp = elem.properties
if (pp) {
for each (var p in pp) if (p) addRow("property", p)}
var ns = elem.namespaceURI
setValue("namespace", ns == xulns? "xul" : ns == htmlns? "html" : "custom")
Marker.mark(elem)}
setValue = function (id, val) {
var textbox = document.getElementById(id)
textbox.value = val
textbox[val? "removeAttribute":"setAttribute"]("disabled", "true")
textbox.previousSibling[val? "removeAttribute":"setAttribute"]("disabled", "true")}
addRow = function (id, val) {
var listbox = document.getElementById(id)
with (listbox.appendChild(document.createElement("listitem")))
setAttribute("label", val),setAttribute("tooltiptext", val)
listbox[val? "removeAttribute":"setAttribute"]("disabled", "true")
listbox.previousSibling[val? "removeAttribute":"setAttribute"]("disabled", "true")}
clearRows = function (id) {
var listbox = document.getElementById(id), c
while (c = listbox.firstChild) listbox.removeChild(c)
listbox.previousSibling.disabled = true}
listboxblur = function (box) {
var i = box.selectedItem
if (i) i.removeAttribute("selected")}
listboxfocus = function (box) {
var i = box.selectedItem
if (i) i.setAttribute("selected", "true")}
goToHome = function () {
elem = original
display()}
goToParent = function () {
elem = parent
display()}
goToChild = function () {
elem = child
display()}
goToPrevious = function () {
elem = previous
display()}
goToNext = function () {
elem = next
display()}
Observer = {
observe: function (subject, topic, data) {
subject.addEventListener("click", onwclick, true)}}
onwclick = function (event) {
if (!event.shiftKey) return
targetWindow = WW.activeWindow
elem = event.originalTarget || event.target
if (elem.localName == "treechildren") {
var box = elem.parentNode.treeBoxObject
var row = {}, col = {}, type = {}
box.getCellAt(event.clientX, event.clientY, row, col, type)
var cc = elem.parentNode.columns, i = 0
while (cc.getColumnAt(i) != col.value) ++i
if (row.value >= 0) elem = new Fake(elem.parentNode, row.value, i, type.value)}
with (document.getElementById("goto-home"))
disabled = (elem == window.arguments[0]),setAttribute("tooltiptext", elem.localName)
original = elem
display()
focus()}
onload = function () {
var ww = WW.getWindowEnumerator()
while (ww.hasMoreElements()) {
var w = ww.getNext().QueryInterface(Components.interfaces.nsIDOMEventTarget)
if (w != self) w.addEventListener("click", onwclick, true)}
OBS.addObserver(Observer, "domwindowopened", false)
document.getElementById("open-button").focus()
var gg = document.getElementsByTagName("grid"), w = 0
for (var i = 0; i < gg.length; ++i) {
var g = gg[i]
w = Math.max(g.firstChild.firstChild.boxObject.width, w)}
for (var i = 0; i < gg.length; ++i) {
var g = gg[i]
g.firstChild.firstChild.setAttribute("width", w)}
clearRows("class")
clearRows("attribute")
clearRows("property")}
onunload = function () {
var ww = WW.getWindowEnumerator()
while (ww.hasMoreElements()) {
var w = ww.getNext().QueryInterface(Components.interfaces.nsIDOMEventTarget)
if (w != self) w.removeEventListener("click", onwclick, true)}
OBS.removeObserver(Observer, "domwindowopened", false)
Marker.cancel()}
openCSS = function () {
var p = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UChrm", Components.interfaces.nsILocalFile)
p.append(document.getElementById("css-file").value)
if (!p.exists()) p.create(0, 0700)
try {p.launch()}
catch (ex) {
var u = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(p)
Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService).loadUrl(u)}}
showPseud = function (pseud) {
document.getElementById("grid-deck").selectedIndex = pseud? 1:0}
Marker = {
signal: null,opacity: 0,timer: null,color: PRF.getCharPref("flash.color"),delay: PRF.getIntPref("flash.time"),mark: function (elem) {
if (this.signal) this.cancel()
var box = elem.boxObject
if (!box) {
var op = elem.offsetParent
box = {
x: elem.offsetLeft - (op? op.scrollLeft : 0),y: elem.offsetTop - (op? op.scrollTop : 0),width: elem.offsetWidth,height: elem.offsetHeight}}
if (box.width == 0 && box.height == 0) return
var doc = elem.ownerDocument
this.signal = doc.documentElement.appendChild(doc.createElement("box"))
this.opacity = .8
with (this.signal.style)
width = (box.width || 1) + "px",height = (box.height || 1) + "px",backgroundColor = this.color,opacity = this.opacity,position = "fixed",top = (box.y - 1) + "px",left = (box.x - 1) + "px",zIndex = "99"
this.timer = setTimeout(Marker.clear, this.delay)},cancel: function () {
if (!this.signal) return
this.signal.parentNode.removeChild(this.signal)
this.signal = null
if (this.timer) clearTimeout(this.timer), this.timer = null},clear: function () {
Marker.timer = null
if (!Marker.signal) return
Marker.opacity -= .05
if (Marker.opacity > 0) {
Marker.signal.style.opacity = Marker.opacity
Marker.timer = setTimeout(Marker.clear, Math.floor(Marker.delay / 10))}
else Marker.cancel()}}